.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include wsock32.inc
includelib wsock32.lib

;**********************************************************************************************************

.data
err         db "Error",0
errSock     db "WinSock Startup Error!",0
errAddr     db "Error getting host address!",0
errName     db "Error getting host name!",0

.data?
WSAData     WSADATA <>
HostName    db 256 dup (?)
HostAddr    db 256 dup (?)

.code
start:
    invoke WSAStartup, 101h,ADDR WSAData
    or eax,eax
    jnz @sockerr

    invoke gethostname, ADDR HostName,SIZEOF HostName
    or eax,eax
    jnz @namerr

    invoke gethostbyname, ADDR HostName
    or eax,eax
    jz @noname
    push edi
    push esi
    mov edi,OFFSET HostAddr
    mov eax,[eax+12] ;;hostent.h_list
    mov edx,eax
  @1:
    mov eax,[edx]
    or eax,eax
    jz @show
    mov eax,[eax]
    push edx
    invoke inet_ntoa, eax
    mov esi,eax
  @@:
    mov al,[esi]
    mov [edi],al
    inc edi
    inc esi
    or al,al
    jnz @B
    dec edi
    mov BYTE PTR[edi],13
    inc edi
    pop edx
    add edx,4
    jmp @1

  @show:
    dec edi
    mov [edi],al ;since jmp was because eax==0
    pop esi
    pop edi
    invoke MessageBox, NULL,ADDR HostAddr,ADDR HostName,MB_OK
  @out:
    invoke ExitProcess, NULL

  @sockerr:
    invoke MessageBox, NULL,ADDR errSock,ADDR err,MB_OK or MB_ICONERROR
    jmp @out
  @namerr:
    invoke MessageBox, NULL,ADDR errName,ADDR err,MB_OK or MB_ICONERROR
    jmp @out
  @noname: 
    invoke MessageBox, NULL,ADDR errAddr,ADDR HostName,MB_OK or MB_ICONERROR
    jmp @out

;**********************************************************************************************************

end start
